org.jgroups.protocols

## Class RATE_LIMITER

- java.lang.Object
- - org.jgroups.stack.Protocol
  - - org.jgroups.protocols.RATE_LIMITER

    public class RATE_LIMITER
    extends Protocol

Protocol which sends at most max_bytes in time_period milliseconds. Can be used instead of a flow control protocol, e.g. FC or SFC (same position in the stack)

Author:
  Bela Ban

### Field Summary

Fields
`protected java.util.concurrent.locks.Condition` `block`
`protected long` `end_of_current_period`
`protected java.util.concurrent.locks.Lock` `lock`
`protected long` `max_bytes`
`protected int` `num_blockings`
`protected long` `num_bytes_sent` Keeps track of the number of bytes sent in the current time period
`protected long` `time_period`
`protected long` `total_block_time`

### Fields inherited from class org.jgroups.stack.Protocol

`down_prot, ergonomics, id, log, name, stack, stats, up_prot`

### Constructor Summary

Constructors
Constructor and Description
`RATE_LIMITER()`

### Method Summary

Methods
`java.lang.Object` `down(Event evt)` An event is to be sent down the stack.
`void` `init()` Called after instance has been created (null constructor) and before protocol is started.
`protected void` `reset()`
`void` `stop()` This method is called on a `Channel.disconnect()`.

### Methods inherited from class org.jgroups.stack.Protocol

`destroy, downThreadEnabled, dumpStats, enableStats, getConfigurableObjects, getDownProtocol, getId, getLevel, getName, getProperties, getProtocolStack, getSocketFactory, getThreadFactory, getTransport, getUpProtocol, getValue, isErgonomics, printStats, providedDownServices, providedUpServices, requiredDownServices, requiredUpServices, resetStats, setDownProtocol, setErgonomics, setId, setLevel, setProperties, setPropertiesInternal, setProperty, setProtocolStack, setSocketFactory, setUpProtocol, setValue, setValues, start, statsEnabled, up, upThreadEnabled`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### max_bytes

    protected long max_bytes

#### time_period

    protected long time_period

#### num_bytes_sent

    protected long num_bytes_sent

Keeps track of the number of bytes sent in the current time period

#### end_of_current_period

    protected long end_of_current_period

#### lock

    protected final java.util.concurrent.locks.Lock lock

#### block

    protected final java.util.concurrent.locks.Condition block

#### num_blockings

    protected int num_blockings

#### total_block_time

    protected long total_block_time

### Constructor Detail

#### RATE_LIMITER

    public RATE_LIMITER()

### Method Detail

#### down

    public java.lang.Object down(Event evt)

Description copied from class: `Protocol`
An event is to be sent down the stack. The layer may want to examine its type and perform some action on it, depending on the event's type. If the event is a message MSG, then the layer may need to add a header to it (or do nothing at all) before sending it down the stack using `down_prot.down()`. In case of a GET_ADDRESS event (which tries to retrieve the stack's address from one of the bottom layers), the layer may need to send a new response event back up the stack using `up_prot.up()`.

Overrides:
  `down` in class `Protocol`

#### init

    public void init()
              throws java.lang.Exception

Description copied from class: `Protocol`
Called after instance has been created (null constructor) and before protocol is started. Properties are already set. Other protocols are not yet connected and events cannot yet be sent.

Overrides:
  `init` in class `Protocol`
Throws:
  `java.lang.Exception` - Thrown if protocol cannot be initialized successfully. This will cause the ProtocolStack to fail, so the channel constructor will throw an exception

#### stop

    public void stop()

Description copied from class: `Protocol`
This method is called on a `Channel.disconnect()`. Stops work (e.g. by closing multicast socket). Will be called from top to bottom. This means that at the time of the method invocation the neighbor protocol below is still working. This method will replace the STOP, STOP_OK, CLEANUP and CLEANUP_OK events. The ProtocolStack guarantees that when this method is called all messages in the down queue will have been flushed

Overrides:
  `stop` in class `Protocol`

#### reset

    protected void reset()